/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <nana/gui.hpp>
#include <nana/gui/widgets/menubar.hpp>
#include <string>
#include <list>

namespace mc::psx {
class MemoryCard;
} //namespace mc::psx

namespace duck {
namespace widget {
class PSXMCGrid;
} //namespace widget

class MainWindow : public nana::form {
public:
	MainWindow (int icon_size, int icon_fps, const std::string& caption);
	~MainWindow() noexcept;

	void open_file_from_dialog();

private:
	void init_menu();

	nana::menubar m_menubar;
	std::list<mc::psx::MemoryCard> m_memcards;
	std::list<duck::widget::PSXMCGrid> m_grids;
	int m_icon_size;
	int m_icon_fps;
};
} //namespace duck
