/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <QMainWindow>
#include <list>

class QApplication;
class QGridLayout;

namespace mc::psx {
class MemoryCard;
} //namespace mc::psx

namespace duck {

class MemoservWin : public QMainWindow
{
    Q_OBJECT

public:
    explicit MemoservWin(QApplication*, QWidget *parent = nullptr);
    ~MemoservWin() noexcept;

private:
	void create_menu(QApplication*);
	void show_version_info();

	void open_file_from_dialog();

	std::list<mc::psx::MemoryCard> m_memcards;
	QGridLayout* m_main_lay;
	unsigned int m_grid_count;
};

} //namespace duck
