/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "animated_icon.hpp"
#include <QWidget>
#include <memory>
#include <vector>

class QGridLayout;

namespace duck::widget {
class BlockGrid : public QWidget {
	Q_OBJECT
public:
	explicit BlockGrid (QWidget* parent=nullptr);
	BlockGrid (QWidget* parent, unsigned int columns);
	~BlockGrid() noexcept;

	QSize minimumSizeHint() const override;
	QSize sizeHint() const override;

	unsigned int icon_width() const;
	unsigned int icon_height() const;

	void emplace_back (std::unique_ptr<AnimatedIcon>&& anim);
	std::size_t size() const;

private:
	std::vector<AnimatedIcon*> m_icons;
	unsigned int m_columns;
	QGridLayout* m_block_lay;
};
} //namespace duck::widget
